import { Flag } from 'magic-regexp';
export * from 'magic-regexp';
import { z } from 'zod';

declare enum REGEXP_FLAGS {
    /** Case-insensitive search */
    caseInsensitive = "i",
    /** Allows `.` to match newline characters */
    dotAll = "s",
    /** Global search */
    global = "g",
    /** Generate indices for substring matches */
    withIndices = "d",
    /** Multi-line search */
    multiline = "m",
    /** Treat a pattern as a sequence of unicode code points */
    unicode = "u",
    /** Perform a "sticky" search that matches starting at the current position in the target string */
    sticky = "y"
}
type RegExpFlagName = keyof typeof REGEXP_FLAGS;
declare const REGEXP_FLAG_SCHEMA: z.ZodNativeEnum<typeof REGEXP_FLAGS>;
declare function validateRegExpFlag(flag: string): Flag;
declare function isValidRegExpFlag(flag: string): flag is Flag;
type RegExpOptions = Partial<{
    [name in RegExpFlagName]: boolean;
}>;
declare function setRegExpFlags(options: RegExpOptions): Array<Flag>;

export { REGEXP_FLAGS, REGEXP_FLAG_SCHEMA, RegExpFlagName, RegExpOptions, isValidRegExpFlag, setRegExpFlags, validateRegExpFlag };
